diff --git a/python/mozbuild/mozpack/errors.py b/python/mozbuild/mozpack/errors.py
index 8b4b80072b..70867db89b 100644
--- a/python/mozbuild/mozpack/errors.py
+++ b/python/mozbuild/mozpack/errors.py
@@ -2,7 +2,6 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
-from __future__ import absolute_import
 
 import sys
 from contextlib import contextmanager
@@ -16,7 +15,7 @@ class AccumulatedErrors(Exception):
     '''Exception type raised from errors.accumulate()'''
 
 
-class ErrorCollector(object):
+class ErrorCollector:
     '''
     Error handling/logging class. A global instance, errors, is provided for
     convenience.
@@ -89,7 +88,7 @@ class ErrorCollector(object):
         if self._context:
             file, line = self._context[-1]
             return "%s: %s:%d: %s" % (level, file, line, msg)
-        return "%s: %s" % (level, msg)
+        return "{}: {}".format(level, msg)
 
     def _handle(self, level, msg):
         msg = self._full_message(level, msg)
@@ -97,7 +96,7 @@ class ErrorCollector(object):
             if self._count is None:
                 raise ErrorMessage(msg)
             self._count += 1
-        print >>self.out, msg
+        print(msg, file=self.out)
 
     def fatal(self, msg):
         self._handle(self.FATAL, msg)
diff --git a/python/mozbuild/mozpack/executables.py b/python/mozbuild/mozpack/executables.py
index 7a4fd0a0d3..68302154c8 100644
--- a/python/mozbuild/mozpack/executables.py
+++ b/python/mozbuild/mozpack/executables.py
@@ -2,7 +2,6 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
-from __future__ import absolute_import
 
 import os
 import struct
diff --git a/python/mozbuild/mozpack/files.py b/python/mozbuild/mozpack/files.py
index 6848e5ccc0..49a028cc7a 100644
--- a/python/mozbuild/mozpack/files.py
+++ b/python/mozbuild/mozpack/files.py
@@ -2,7 +2,6 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
-from __future__ import absolute_import
 
 import errno
 import os
@@ -57,7 +56,7 @@ else:
 
     def _copyfile(src, dest):
         # False indicates `dest` should be overwritten if it exists already.
-        if isinstance(src, unicode) and isinstance(dest, unicode):
+        if isinstance(src, str) and isinstance(dest, str):
             _CopyFileW(src, dest, False)
         elif isinstance(src, str) and isinstance(dest, str):
             _CopyFileA(src, dest, False)
@@ -145,13 +144,13 @@ class BaseFile(object):
         # - keep file type (e.g. S_IFREG)
         ret = stat.S_IFMT(mode)
         # - expand user read and execute permissions to everyone
-        if mode & 0400:
-            ret |= 0444
-        if mode & 0100:
-            ret |= 0111
+        if mode & 0o400:
+            ret |= 0o444
+        if mode & 0o100:
+            ret |= 0o111
         # - keep user write permissions
-        if mode & 0200:
-            ret |= 0200
+        if mode & 0o200:
+            ret |= 0o200
         # - leave away sticky bit, setuid, setgid
         return ret
 
@@ -164,7 +163,7 @@ class BaseFile(object):
         disabled when skip_if_older is False.
         Returns whether a copy was actually performed (True) or not (False).
         '''
-        if isinstance(dest, basestring):
+        if isinstance(dest, str):
             dest = Dest(dest)
         else:
             assert isinstance(dest, Dest)
@@ -185,12 +184,12 @@ class BaseFile(object):
             else:
                 # Ensure the file is always created
                 if not dest.exists():
-                    dest.write('')
+                    dest.write(b'')
                 shutil.copyfileobj(self.open(), dest)
             return True
 
         src = self.open()
-        copy_content = ''
+        copy_content = b''
         while True:
             dest_content = dest.read(32768)
             src_content = src.read(32768)
@@ -258,11 +257,11 @@ class ExecutableFile(File):
     '''
     def copy(self, dest, skip_if_older=True):
         real_dest = dest
-        if not isinstance(dest, basestring):
+        if not isinstance(dest, str):
             fd, dest = mkstemp()
             os.close(fd)
             os.remove(dest)
-        assert isinstance(dest, basestring)
+        assert isinstance(dest, str)
         # If File.copy didn't actually copy because dest is newer, check the
         # file sizes. If dest is smaller, it means it is already stripped and
         # elfhacked, so we can skip.
@@ -299,7 +298,7 @@ class AbsoluteSymlinkFile(File):
         File.__init__(self, path)
 
     def copy(self, dest, skip_if_older=True):
-        assert isinstance(dest, basestring)
+        assert isinstance(dest, str)
         from buildconfig import substs
 
         # The logic in this function is complicated by the fact that symlinks
@@ -402,7 +401,7 @@ class ExistingFile(BaseFile):
         self.required = required
 
     def copy(self, dest, skip_if_older=True):
-        if isinstance(dest, basestring):
+        if isinstance(dest, str):
             dest = Dest(dest)
         else:
             assert isinstance(dest, Dest)
@@ -434,7 +433,7 @@ class PreprocessedFile(BaseFile):
         '''
         Invokes the preprocessor to create the destination file.
         '''
-        if isinstance(dest, basestring):
+        if isinstance(dest, str):
             dest = Dest(dest)
         else:
             assert isinstance(dest, Dest)
@@ -497,7 +496,10 @@ class GeneratedFile(BaseFile):
         self.content = content
 
     def open(self):
-        return BytesIO(self.content)
+        content = self.content
+        if isinstance(content, str):
+            content = content.encode('utf-8')
+        return BytesIO(content)
 
 
 class DeflatedFile(BaseFile):
@@ -565,7 +567,7 @@ class XPTFile(GeneratedFile):
         the individual XPTs to link.
         skip_if_older is ignored.
         '''
-        if isinstance(dest, basestring):
+        if isinstance(dest, str):
             dest = Dest(dest)
         assert isinstance(dest, Dest)
 
@@ -644,7 +646,7 @@ class ManifestFile(BaseFile):
         the manifest.
         '''
         return BytesIO(''.join('%s\n' % e.rebase(self._base)
-                               for e in self._entries))
+                               for e in self._entries).encode('utf-8'))
 
     def __iter__(self):
         '''
@@ -1016,7 +1018,7 @@ class ComposedFinder(BaseFinder):
         from mozpack.copier import FileRegistry
         self.files = FileRegistry()
 
-        for base, finder in sorted(finders.iteritems()):
+        for base, finder in sorted(finders.items()):
             if self.files.contains(base):
                 self.files.remove(base)
             for p, f in finder.find(''):
diff --git a/python/mozbuild/mozpack/hg.py b/python/mozbuild/mozpack/hg.py
index 79876061f4..0d400ddca9 100644
--- a/python/mozbuild/mozpack/hg.py
+++ b/python/mozbuild/mozpack/hg.py
@@ -27,7 +27,6 @@
 # do not wish to do so, delete this exception statement from your
 # version.
 
-from __future__ import absolute_import
 
 import mercurial.error as error
 import mercurial.hg as hg
@@ -56,13 +55,13 @@ class MercurialNativeRevisionFinder(BaseFinder):
 
         Accepts a Mercurial localrepo and changectx instance.
         """
-        if isinstance(repo, (str, unicode)):
+        if isinstance(repo, (str, str)):
             path = repo
             repo = hg.repository(hgui.ui(), repo)
         else:
             path = repo.root
 
-        super(MercurialNativeRevisionFinder, self).__init__(base=repo.root)
+        super().__init__(base=repo.root)
 
         self._repo = repo
         self._rev = rev
@@ -85,7 +84,7 @@ class MercurialNativeRevisionFinder(BaseFinder):
         return self._get(path)
 
     def _get(self, path):
-        if isinstance(path, unicode):
+        if isinstance(path, str):
             path = path.encode('utf-8', 'replace')
 
         try:
diff --git a/python/mozbuild/mozpack/manifests.py b/python/mozbuild/mozpack/manifests.py
index b77931101a..1f80a345ee 100644
--- a/python/mozbuild/mozpack/manifests.py
+++ b/python/mozbuild/mozpack/manifests.py
@@ -2,7 +2,6 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
-from __future__ import absolute_import, unicode_literals
 
 from contextlib import contextmanager
 import json
@@ -41,7 +40,7 @@ class UnreadableInstallManifest(Exception):
     """Raised when an invalid install manifest is parsed."""
 
 
-class InstallManifest(object):
+class InstallManifest:
     """Describes actions to be used with a copier.FileCopier instance.
 
     This class facilitates serialization and deserialization of data used to
@@ -115,7 +114,7 @@ class InstallManifest(object):
         self._source_files = set()
 
         if path or fileobj:
-            with _auto_fileobj(path, fileobj, 'rb') as fh:
+            with _auto_fileobj(path, fileobj, 'r') as fh:
                 self._source_files.add(fh.name)
                 self._load_from_fileobj(fh)
 
@@ -236,7 +235,7 @@ class InstallManifest(object):
 
         It is an error if both are specified.
         """
-        with _auto_fileobj(path, fileobj, 'wb') as fh:
+        with _auto_fileobj(path, fileobj, 'w') as fh:
             fh.write('%d\n' % self.CURRENT_VERSION)
 
             for dest in sorted(self._dests):
@@ -251,12 +250,12 @@ class InstallManifest(object):
                         source = mozpath.join(base, path)
                         parts = ['%d' % type, mozpath.join(dest, path), source]
                         fh.write('%s\n' % self.FIELD_SEPARATOR.join(
-                            p.encode('utf-8') for p in parts))
+                            p for p in parts))
                 else:
                     parts = ['%d' % entry[0], dest]
                     parts.extend(entry[1:])
                     fh.write('%s\n' % self.FIELD_SEPARATOR.join(
-                        p.encode('utf-8') for p in parts))
+                        p for p in parts))
 
     def add_symlink(self, source, dest):
         """Add a symlink to this manifest.
diff --git a/python/mozbuild/mozpack/mozjar.py b/python/mozbuild/mozpack/mozjar.py
index 2010a7f135..7d47b85230 100644
--- a/python/mozbuild/mozpack/mozjar.py
+++ b/python/mozbuild/mozpack/mozjar.py
@@ -2,7 +2,6 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
-from __future__ import absolute_import
 
 from io import BytesIO
 import struct
@@ -14,9 +13,10 @@ from zipfile import (
     ZIP_DEFLATED,
 )
 from collections import OrderedDict
-from urlparse import urlparse, ParseResult
+from urllib.parse import urlparse, ParseResult
 import mozpack.path as mozpath
 from mozbuild.util import memoize
+from functools import reduce
 
 JAR_STORED = ZIP_STORED
 JAR_DEFLATED = ZIP_DEFLATED
@@ -71,7 +71,7 @@ class JarStruct(object):
         an instance with empty fields.
         '''
         assert self.MAGIC and isinstance(self.STRUCT, OrderedDict)
-        self.size_fields = set(t for t in self.STRUCT.itervalues()
+        self.size_fields = set(t for t in self.STRUCT.values()
                                if not t in JarStruct.TYPE_MAPPING)
         self._values = {}
         if data:
@@ -93,7 +93,7 @@ class JarStruct(object):
         # For all fields used as other fields sizes, keep track of their value
         # separately.
         sizes = dict((t, 0) for t in self.size_fields)
-        for name, t in self.STRUCT.iteritems():
+        for name, t in self.STRUCT.items():
             if t in JarStruct.TYPE_MAPPING:
                 value, size = JarStruct.get_data(t, data[offset:])
             else:
@@ -112,10 +112,10 @@ class JarStruct(object):
         Initialize an instance with empty fields.
         '''
         self.signature = self.MAGIC
-        for name, t in self.STRUCT.iteritems():
+        for name, t in self.STRUCT.items():
             if name in self.size_fields:
                 continue
-            self._values[name] = 0 if t in JarStruct.TYPE_MAPPING else ''
+            self._values[name] = 0 if t in JarStruct.TYPE_MAPPING else b''
 
     @staticmethod
     def get_data(type, data):
@@ -137,9 +137,9 @@ class JarStruct(object):
         from self.STRUCT.
         '''
         serialized = struct.pack('<I', self.signature)
-        sizes = dict((t, name) for name, t in self.STRUCT.iteritems()
+        sizes = dict((t, name) for name, t in self.STRUCT.items()
                      if not t in JarStruct.TYPE_MAPPING)
-        for name, t in self.STRUCT.iteritems():
+        for name, t in self.STRUCT.items():
             if t in JarStruct.TYPE_MAPPING:
                 format, size = JarStruct.TYPE_MAPPING[t]
                 if name in sizes:
@@ -148,7 +148,10 @@ class JarStruct(object):
                     value = self[name]
                 serialized += struct.pack('<' + format, value)
             else:
-                serialized += self[name]
+                value = self[name]
+                if isinstance(value, str):
+                    value = value.encode('utf-8')
+                serialized += value
         return serialized
 
     @property
@@ -158,7 +161,7 @@ class JarStruct(object):
         variable length fields.
         '''
         size = JarStruct.TYPE_MAPPING['uint32'][1]
-        for name, type in self.STRUCT.iteritems():
+        for name, type in self.STRUCT.items():
             if type in JarStruct.TYPE_MAPPING:
                 size += JarStruct.TYPE_MAPPING[type][1]
             else:
@@ -179,7 +182,7 @@ class JarStruct(object):
         return key in self._values
 
     def __iter__(self):
-        return self._values.iteritems()
+        return iter(self._values.items())
 
     def __repr__(self):
         return "<%s %s>" % (self.__class__.__name__,
@@ -373,7 +376,7 @@ class JarReader(object):
         entries = self.entries
         if not entries:
             return JAR_STORED
-        return max(f['compression'] for f in entries.itervalues())
+        return max(f['compression'] for f in entries.values())
 
     @property
     def entries(self):
@@ -389,7 +392,7 @@ class JarReader(object):
             preload = JarStruct.get_data('uint32', self._data)[0]
         entries = OrderedDict()
         offset = self._cdir_end['cdir_offset']
-        for e in xrange(self._cdir_end['cdir_entries']):
+        for e in range(self._cdir_end['cdir_entries']):
             entry = JarCdirEntry(self._data[offset:])
             offset += entry.size
             # Creator host system. 0 is MSDOS, 3 is Unix
@@ -400,7 +403,7 @@ class JarReader(object):
             xattr = entry['external_attr']
             # Skip directories
             if (host == 0 and xattr & 0x10) or (host == 3 and
-                                                xattr & (040000 << 16)):
+                                                xattr & (0o40000 << 16)):
                 continue
             entries[entry['filename']] = entry
             if entry['offset'] < preload:
@@ -451,7 +454,7 @@ class JarReader(object):
             for file in jarReader:
                 ...
         '''
-        for entry in self.entries.itervalues():
+        for entry in self.entries.values():
             yield self._getreader(entry)
 
     def __getitem__(self, name):
@@ -546,7 +549,7 @@ class JarWriter(object):
         headers = {}
         preload_size = 0
         # Prepare central directory entries
-        for entry, content in self._contents.itervalues():
+        for entry, content in self._contents.values():
             header = JarLocalFileHeader()
             for name in entry.STRUCT:
                 if name in header:
@@ -561,7 +564,7 @@ class JarWriter(object):
         end['disk_entries'] = len(self._contents)
         end['cdir_entries'] = end['disk_entries']
         end['cdir_size'] = reduce(lambda x, y: x + y[0].size,
-                                  self._contents.values(), 0)
+                                  list(self._contents.values()), 0)
         # On optimized archives, store the preloaded size and the central
         # directory entries, followed by the first end of central directory.
         if self._optimize:
@@ -570,18 +573,18 @@ class JarWriter(object):
             if preload_size:
                 preload_size += offset
             self._data.write(struct.pack('<I', preload_size))
-            for entry, _ in self._contents.itervalues():
+            for entry, _ in self._contents.values():
                 entry['offset'] += offset
                 self._data.write(entry.serialize())
             self._data.write(end.serialize())
         # Store local file entries followed by compressed data
-        for entry, content in self._contents.itervalues():
+        for entry, content in self._contents.values():
             self._data.write(headers[entry].serialize())
             self._data.write(content)
         # On non optimized archives, store the central directory entries.
         if not self._optimize:
             end['cdir_offset'] = offset
-            for entry, _ in self._contents.itervalues():
+            for entry, _ in self._contents.values():
                 self._data.write(entry.serialize())
         # Store the end of central directory.
         self._data.write(end.serialize())
@@ -621,7 +624,7 @@ class JarWriter(object):
             deflater = data
         else:
             deflater = Deflater(compress, compress_level=self._compress_level)
-            if isinstance(data, basestring):
+            if isinstance(data, str):
                 deflater.write(data)
             elif hasattr(data, 'read'):
                 if hasattr(data, 'seek'):
@@ -637,7 +640,7 @@ class JarWriter(object):
             # Set creator host system (upper byte of creator_version)
             # to 3 (Unix) so mode is honored when there is one.
             entry['creator_version'] |= 3 << 8
-            entry['external_attr'] = (mode & 0xFFFF) << 16L
+            entry['external_attr'] = (mode & 0xFFFF) << 16
         if deflater.compressed:
             entry['min_version'] = 20  # Version 2.0 supports deflated streams
             entry['general_flag'] = 2  # Max compression
diff --git a/python/mozbuild/mozpack/packager/__init__.py b/python/mozbuild/mozpack/packager/__init__.py
index 4c98ec3d33..31c666b03c 100644
--- a/python/mozbuild/mozpack/packager/__init__.py
+++ b/python/mozbuild/mozpack/packager/__init__.py
@@ -2,7 +2,6 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
-from __future__ import absolute_import
 
 from mozbuild.preprocessor import Preprocessor
 import re
@@ -20,7 +19,7 @@ import mozpack.path as mozpath
 from collections import deque
 
 
-class Component(object):
+class Component:
     '''
     Class that represents a component in a package manifest.
     '''
@@ -50,7 +49,7 @@ class Component(object):
         '''
         Split [1, 2, 3, 4, 5, 6, 7] into [(1, 2, 3), (4, 5, 6)].
         '''
-        return zip(*[iter(lst)] * 3)
+        return list(zip(*[iter(lst)] * 3))
 
     KEY_VALUE_RE = re.compile(r'''
         \s*                 # optional whitespace.
@@ -100,7 +99,7 @@ class Component(object):
         component = splits[0].strip()
         if not component:
             raise ValueError('No component found')
-        if not re.match('[a-zA-Z0-9_\-]+$', component):
+        if not re.match(r'[a-zA-Z0-9_\-]+$', component):
             raise ValueError('Bad component name ' + component)
         options = Component._split_options(splits[1]) if len(splits) > 1 else {}
         return component, options
@@ -118,11 +117,11 @@ class Component(object):
         destdir = options.pop('destdir', '')
         if options:
             errors.fatal('Malformed manifest: options %s not recognized'
-                         % options.keys())
+                         % list(options.keys()))
         return Component(name, destdir=destdir)
 
 
-class PackageManifestParser(object):
+class PackageManifestParser:
     '''
     Class for parsing of a package manifest, after preprocessing.
 
@@ -166,7 +165,7 @@ class PackageManifestParser(object):
             self._sink.add(self._component, str)
 
 
-class PreprocessorOutputWrapper(object):
+class PreprocessorOutputWrapper:
     '''
     File-like helper to handle the preprocessor output and send it to a parser.
     The parser's handle_line method is called in the relevant errors.context.
@@ -222,7 +221,7 @@ class CallDeque(deque):
                 function(*args)
 
 
-class SimplePackager(object):
+class SimplePackager:
     '''
     Helper used to translate and buffer instructions from the
     SimpleManifestSink to a formatter. Formatters expect some information to be
@@ -267,6 +266,8 @@ class SimplePackager(object):
             if mozpath.basename(path) == 'install.rdf':
                 addon = True
                 install_rdf = file.open().read()
+                if isinstance(install_rdf, bytes):
+                    install_rdf = install_rdf.decode('utf-8', errors='replace')
                 if self.UNPACK_ADDON_RE.search(install_rdf):
                     addon = 'unpacked'
                 self._addons[mozpath.dirname(path)] = addon
@@ -309,9 +310,9 @@ class SimplePackager(object):
         manifests are manifests that are included in no other manifest.
         `addons` indicates whether to include addon bases as well.
         '''
-        all_bases = set(mozpath.dirname(m)
+        all_bases = {mozpath.dirname(m)
                         for m in self._manifests
-                                 - set(self._included_manifests))
+                                 - set(self._included_manifests)}
         if not addons:
             all_bases -= set(self._addons)
         else:
@@ -328,7 +329,7 @@ class SimplePackager(object):
 
         bases = self.get_bases()
         broken_bases = sorted(
-            m for m, includer in self._included_manifests.iteritems()
+            m for m, includer in self._included_manifests.items()
             if mozpath.basedir(m, bases) != mozpath.basedir(includer, bases))
         for m in broken_bases:
             errors.fatal('"%s" is included from "%s", which is outside "%s"' %
@@ -341,7 +342,7 @@ class SimplePackager(object):
         self._file_queue.execute()
 
 
-class SimpleManifestSink(object):
+class SimpleManifestSink:
     '''
     Parser sink for "simple" package manifests. Simple package manifests use
     the format described in the PackageManifestParser documentation, but don't
diff --git a/python/mozbuild/mozpack/packager/formats.py b/python/mozbuild/mozpack/packager/formats.py
index 235fc3e90f..3442945b5f 100644
--- a/python/mozbuild/mozpack/packager/formats.py
+++ b/python/mozbuild/mozpack/packager/formats.py
@@ -2,7 +2,6 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
-from __future__ import absolute_import
 
 from mozpack.chrome.manifest import (
     Manifest,
@@ -11,7 +10,7 @@ from mozpack.chrome.manifest import (
     ManifestBinaryComponent,
     ManifestResource,
 )
-from urlparse import urlparse
+from urllib.parse import urlparse
 import mozpack.path as mozpath
 from mozpack.files import (
     ManifestFile,
@@ -67,7 +66,7 @@ data.
 '''
 
 
-class PiecemealFormatter(object):
+class PiecemealFormatter:
     '''
     Generic formatter that dispatches across different sub-formatters
     according to paths.
@@ -89,7 +88,7 @@ class PiecemealFormatter(object):
         Return the deepest base directory containing the given path.
         '''
         self._frozen_bases = True
-        base = mozpath.basedir(path, self._sub_formatter.keys())
+        base = mozpath.basedir(path, list(self._sub_formatter.keys()))
         relpath = mozpath.relpath(path, base) if base else path
         return base, relpath
 
@@ -126,7 +125,7 @@ class FlatFormatter(PiecemealFormatter):
             FileRegistrySubtree(base, self.copier))
 
 
-class FlatSubFormatter(object):
+class FlatSubFormatter:
     '''
     Sub-formatter for the flat package format.
     '''
diff --git a/python/mozbuild/mozpack/packager/l10n.py b/python/mozbuild/mozpack/packager/l10n.py
index e3e05fc894..3604168454 100644
--- a/python/mozbuild/mozpack/packager/l10n.py
+++ b/python/mozbuild/mozpack/packager/l10n.py
@@ -2,7 +2,6 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
-from __future__ import absolute_import
 
 '''
 Replace localized parts of a packaged directory with data from a langpack
@@ -42,12 +41,12 @@ from mozpack.packager.unpack import UnpackFinder
 from createprecomplete import generate_precomplete
 
 
-class LocaleManifestFinder(object):
+class LocaleManifestFinder:
     def __init__(self, finder):
         entries = self.entries = []
         bases = self.bases = []
 
-        class MockFormatter(object):
+        class MockFormatter:
             def add_interfaces(self, path, content):
                 pass
 
@@ -66,7 +65,7 @@ class LocaleManifestFinder(object):
         # Those type of entries are used by language packs to work as addons,
         # but are not necessary for the purpose of l10n repacking. So we wrap
         # the finder in order to remove those entries.
-        class WrapFinder(object):
+        class WrapFinder:
             def __init__(self, finder):
                 self._finder = finder
 
@@ -88,8 +87,8 @@ class LocaleManifestFinder(object):
         sink.close(False)
 
         # Find unique locales used in these manifest entries.
-        self.locales = list(set(e.id for e in self.entries
-                                if isinstance(e, ManifestLocale)))
+        self.locales = list({e.id for e in self.entries
+                                if isinstance(e, ManifestLocale)})
 
 
 def _repack(app_finder, l10n_finder, copier, formatter, non_chrome=set()):
@@ -140,8 +139,8 @@ def _repack(app_finder, l10n_finder, copier, formatter, non_chrome=set()):
     for pattern in non_chrome:
         for base in app.bases:
             path = mozpath.join(base, pattern)
-            left = set(p for p, f in app_finder.find(path))
-            right = set(p for p, f in l10n_finder.find(path))
+            left = {p for p, f in app_finder.find(path)}
+            right = {p for p, f in l10n_finder.find(path)}
             for p in right:
                 paths[p] = p
             for p in left - right:
@@ -163,7 +162,7 @@ def _repack(app_finder, l10n_finder, copier, formatter, non_chrome=set()):
             if not path:
                 continue
         else:
-            base = mozpath.basedir(p, paths.keys())
+            base = mozpath.basedir(p, list(paths.keys()))
             if base:
                 subpath = mozpath.relpath(p, base)
                 path = mozpath.normpath(mozpath.join(paths[base],
@@ -184,7 +183,7 @@ def _repack(app_finder, l10n_finder, copier, formatter, non_chrome=set()):
 
     # Add localized manifest entries from the langpack.
     l10n_manifests = []
-    for base in set(e.base for e in l10n.entries):
+    for base in {e.base for e in l10n.entries}:
         m = ManifestFile(base, [e for e in l10n.entries if e.base == base])
         path = mozpath.join(base, 'chrome.%s.manifest' % l10n_locale)
         l10n_manifests.append((path, m))
@@ -207,7 +206,7 @@ def _repack(app_finder, l10n_finder, copier, formatter, non_chrome=set()):
                     formatter.add(p, f)
 
     # Transplant jar preloading information.
-    for path, log in app_finder.jarlogs.iteritems():
+    for path, log in app_finder.jarlogs.items():
         assert isinstance(copier[path], Jarrer)
         copier[path].preload([l.replace(locale, l10n_locale) for l in log])
 
@@ -238,7 +237,7 @@ def repack(source, l10n, extra_l10n={}, non_resources=[], non_chrome=set()):
         finders = {
             '': l10n_finder,
         }
-        for base, path in extra_l10n.iteritems():
+        for base, path in extra_l10n.items():
             finders[base] = UnpackFinder(path)
         l10n_finder = ComposedFinder(finders)
     copier = FileCopier()
diff --git a/python/mozbuild/mozpack/packager/unpack.py b/python/mozbuild/mozpack/packager/unpack.py
index 515705c0d7..b28a3fc20a 100644
--- a/python/mozbuild/mozpack/packager/unpack.py
+++ b/python/mozbuild/mozpack/packager/unpack.py
@@ -2,7 +2,6 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
-from __future__ import absolute_import
 
 import mozpack.path as mozpath
 from mozpack.files import (
@@ -27,7 +26,7 @@ from mozpack.packager.formats import (
     FlatFormatter,
     STARTUP_CACHE_PATHS,
 )
-from urlparse import urlparse
+from urllib.parse import urlparse
 
 
 class UnpackFinder(BaseFinder):
@@ -148,7 +147,7 @@ class UnpackFinder(BaseFinder):
             self.optimizedjars = True
         self.compressed = max(self.compressed, jar.compression)
         if jar.last_preloaded:
-            jarlog = jar.entries.keys()
+            jarlog = list(jar.entries.keys())
             self.jarlogs[path] = jarlog[:jarlog.index(jar.last_preloaded) + 1]
         return jar
 
diff --git a/python/mozbuild/mozpack/path.py b/python/mozbuild/mozpack/path.py
index 7ea8ea85ad..239c226dce 100644
--- a/python/mozbuild/mozpack/path.py
+++ b/python/mozbuild/mozpack/path.py
@@ -2,7 +2,6 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
-from __future__ import absolute_import
 
 import posixpath
 import os
diff --git a/python/mozbuild/mozpack/test/support/minify_js_verify.py b/python/mozbuild/mozpack/test/support/minify_js_verify.py
index 8e4e8b7590..d4cffb7b3b 100644
--- a/python/mozbuild/mozpack/test/support/minify_js_verify.py
+++ b/python/mozbuild/mozpack/test/support/minify_js_verify.py
@@ -2,7 +2,6 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
-from __future__ import print_function
 import sys
 
 
